import java.awt.*;
import javax.swing.*;

/**
 * A program that draws a sampler quilt
 * 
 * @author YOUR NAME HERE
 */
public class Quilt extends JPanel
{
    //sizing constants
    public final int ROWS; //number of rows and cols
    public final int COLS;
    public final int PATCH_SIZE = 100; //size of each patch in pixels. For high-res monitors, change this to 200.

    /**
     * Creates a new 5x7 quilt.
     */
    public Quilt()
    {
        this(5,7); //calls other constructor with these parameters
    }

    /**
     * Creates a new quilt with the given number of rows and columns
     * @param rows The number of rows
     * @param cols The number of cols
     */
    public Quilt(int rows, int cols)
    {
        ROWS = rows; //can make quilt bigger, though the size is constant once created
        COLS = cols;
        this.setPreferredSize(new Dimension(PATCH_SIZE*COLS, PATCH_SIZE*ROWS)); //specify the size of the quilt in pixels

        //creates the window to show the quilt
        JFrame frame = new JFrame("Sampler Quilt");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); //stop program when hit close
        frame.setResizable(false);
        frame.add(this); //put this quilt in the frame
        frame.pack(); //size everything
        frame.setVisible(true); //show the frame
    }

    /**
     * This method actually draws the quilt. It is called automatically (by Java)
     * when the window appears. You never call this yourself.
     * @param brush The Graphics paintbrush to draw with.
     */
    public void paintComponent(Graphics brush)
    {
        //make background white
        brush.setColor(Color.WHITE);
        brush.fillRect(0, 0, COLS*PATCH_SIZE, ROWS*PATCH_SIZE); 

        
        //TODO: draw your quilt here! (and remove this comment)

        
        this.drawGrid(brush); //draws an outline "grid" for the patches
    }

    /**
     * Draws an grid using the given graphics brush
     * @param brush the Graphics paintbrush to draw with.
     */
    public void drawGrid(Graphics brush)
    {
        brush.setColor(Color.BLACK); //change the color to black
        for(int i=0; i<=ROWS; i++) //draw the rows
        {
            brush.drawLine(0, i*PATCH_SIZE, PATCH_SIZE*COLS, i*PATCH_SIZE);
        }
        for(int i=0; i<=COLS; i++) //draw the cols
        {
            brush.drawLine(i*PATCH_SIZE, 0, i*PATCH_SIZE, PATCH_SIZE*ROWS);
        }

    }


    //TODO: Your methods go here!

    
}
